sub clamuko_scanner {
  #Clamuko scanner
  &debug("clamuko: starting scan of directory \"$ENV{'TMPDIR'}\"...");

  my ($start_clamuko_time)=[gettimeofday];
  my ($DD,$clamuko_status,$stop_clamuko_time,$clamuko_time);
  my ($clamuko_verbose,$clamuko_status);
  $clamuko_verbose="-v" if ($DEBUG);

  &debug("run $clamuko_binary $clamuko_options  $ENV{'TMPDIR'} 2>&1");

  $DD=`$clamuko_binary $clamuko_options $ENV{'TMPDIR'} 2>&1`;
  $clamuko_status=($? >> 8);

  &debug("--output of clamuko was:\n$DD--");

  if ( $clamuko_status > 0 ) {
    if ($clamuko_status == 1 && $DD =~ /\:\s(.*)\sFOUND$/m) {
      $quarantine_description=$+;
      &debug("There be a virus! ($quarantine_description)");
      ($quarantine_event=$quarantine_description)=~s/\s/_/g;
      $quarantine_event="CLAMUKO:".substr($quarantine_event,0,$QE_LEN);
      $description .= "\n---clamuko results ---\n$DD";
    } else {
      #This implies a corrupt set of DAT files or resource problems...
      &error_condition("clamuko: corrupt or unknown clamd scanner error or memory/resource/perms problem - exit status $clamuko_status");
    }
  } else {
    if ($DD =~ /Recursion limit exceeded/) {
      $quarantine_description="Resource attack - $1";
      &debug("clamuko: $quarantine_description");
      $quarantine_event="CLAMUKO:Resource_attack";
      $description .= "\n---clamuko results ---\n$DD";
    }
  }
  
  $stop_clamuko_time=[gettimeofday];
  $clamuko_time = tv_interval ($start_clamuko_time, $stop_clamuko_time);
  &debug("clamuko: finished scan of dir \"$ENV{'TMPDIR'}\" in $clamuko_time secs");
}
